#define MAX_WIDTH 128
#define MAX_HEIGHT 256 /* don't make this smaller than 256 */

typedef struct CharAttrib {
	unsigned char bold;
	unsigned int italics;
	unsigned char under;
	unsigned char reverse;
	unsigned char blink;
	/*unsigned char dhtop;
	unsigned char dhbot;
	unsigned char dw;*/
} CharAttrib;

typedef struct Char {
	char character[UTFmax];
	CharAttrib state;
} Char;

extern void screen_init(char *label);
extern void screen_plot(int x, int y, char *c);
extern void screen_status(char *s);
extern void screen_cursor(int x, int y);
extern void screen_scroll(int lines,int top,int bottom);
extern void screen_blank(void);
extern void screen_delete(int x0, int y0, int x1, int y1);
extern void screen_redraw(void);
/*extern void screen_reshaped(void);*/

extern Char chararray[MAX_WIDTH][MAX_HEIGHT];
extern char tabarray[MAX_WIDTH];
extern int maxx;
extern int maxy;
extern int scroll_offset;
extern int curx=0;
extern int cury=0;
extern int saved_curx=0;
extern int saved_cury=0;
extern char *status;
extern CharAttrib default_attrib;
extern CharAttrib attrib;
extern CharAttrib saved_attrib;
extern Lock screen_lock;