#include <u.h>
#include <libc.h>
#include <libg.h>
#include <lock.h>

#include "io.h"
#include "chararray.h"
#include "menu.h"

#define BUFFER 256

static char input_buf[BUFFER]; /*beware shared memory!!*/
static int current_byte=0;
static int max_byte=0;

int
kbdcheck(void)
{
	int r;

	lock(&screen_lock);
	r=ecankbd();
	unlock(&screen_lock);
	return r;
}

void
input(int fd)
{
	int c;
	char s[UTFmax];

	for (;;) {
		while (!kbdcheck()) sleep(10);
		lock(&screen_lock);
		c=ekbd();
		unlock(&screen_lock);
		/*output_beep();*/
		switch (c) {
			case 0xfd5e:
				write(fd,"\033[A",3);
				break;
			case 0xfd53:
				write(fd,"\033[B",3);
				break;
			case 0xfd52:
				write(fd,"\033[C",3);
				break;
			case 0xfd51:
				write(fd,"\033[D",3);
				break;
			default:
				runetochar(s,(Rune *)&c);
				write(fd,s,1); /*just ascii for now*/
				break;
		}
	}
	return;
}

int
mousecheck(void)
{
	int r;

	lock(&screen_lock);
	r=ecanmouse();
	unlock(&screen_lock);
	return r;
}

void
input_mouse(void)
{
	Mouse m;

	for (;;) {
		while (!mousecheck()) sleep(10);
		lock(&screen_lock);
		m=emouse();
		if (m.buttons&4) /*button 3 hit */ menu_process(3,&m);
		unlock(&screen_lock);
	}
	return;
}
